//////////////////////////////////////////////////////////////////////////////////
// 
// Create Date:    19:33:53 01/24/2012 
// Module Name:    colors_6 
// 
//////////////////////////////////////////////////////////////////////////////////
`include "c933hdmi_defs.vh"
/*
Color    Color Register    Master Color
Name         Value            Value
---------------------------------------
Black         $0              $0000		
Deep Red      $1              $0D03		
Dark Blue     $2              $0009		
Purple        $3              $0D2D		
Dark Green    $4              $0072		
Dark Gray     $5              $0555		
Medium Blue   $6              $022F		
Light Blue    $7              $06AF		
Brown         $8              $0850		
Orange        $9              $0F60		
Light Gray    $A              $0AAA		
Pink          $B              $0F98		
Light Green   $C              $01D0		
Yellow        $D              $0FF0		
Aquamarine    $E              $04F9		
White         $F              $0FFF		
--------------------------------------- */
module colors_6(
    input [3:0] border_number,
	 input [3:0] text_number,
	 input [3:0] back_number,
	 input [3:0] dhrcolor_number,
	 input [3:0] nibble,
	 output reg [5:0] border_color6,
    output reg [5:0] text_color6,	 
    output reg [5:0] back_color6,
    output reg [5:0] dhr_color6,
	 output reg [5:0] RGB_val   
    );

	always @* begin
		case (border_number)
			4'b0000: border_color6 <= 6'h0;
			4'b0001: border_color6 <= 6'b110000;
			4'b0010: border_color6 <= 6'b000010;
			4'b0011: border_color6 <= 6'b110010;
			4'b0100: border_color6 <= 6'b000100;
			4'b0101: border_color6 <= 6'b010101;
			4'b0110: border_color6 <= 6'b000011;
			4'b0111: border_color6 <= 6'b011011;
			4'b1000: border_color6 <= 6'b100100;
			4'b1001: border_color6 <= 6'b110100;
			4'b1010: border_color6 <= 6'b101010;
			4'b1011: border_color6 <= 6'b111010;
			4'b1100: border_color6 <= 6'b001000;
			4'b1101: border_color6 <= 6'b111100;
			4'b1110: border_color6 <= 6'b001110;
			4'b1111: border_color6 <= 6'b111111;			
		endcase
	end	
	
	always @* begin
		case (text_number)
			4'b0000: text_color6 <= 6'h0;
			4'b0001: text_color6 <= 6'b110000;
			4'b0010: text_color6 <= 6'b000010;
			4'b0011: text_color6 <= 6'b110010;
			4'b0100: text_color6 <= 6'b000100;
			4'b0101: text_color6 <= 6'b010101;
			4'b0110: text_color6 <= 6'b000011;
			4'b0111: text_color6 <= 6'b011011;
			4'b1000: text_color6 <= 6'b100100;
			4'b1001: text_color6 <= 6'b110100;
			4'b1010: text_color6 <= 6'b101010;
			4'b1011: text_color6 <= 6'b111010;
			4'b1100: text_color6 <= 6'b001000;
			4'b1101: text_color6 <= 6'b111100;
			4'b1110: text_color6 <= 6'b001110;
			4'b1111: text_color6 <= 6'b111111;			
		endcase
	end	
	
	always @* begin
		case (back_number)
			4'b0000: back_color6 <= 6'h0;
			4'b0001: back_color6 <= 6'b110000;
			4'b0010: back_color6 <= 6'b000010;
			4'b0011: back_color6 <= 6'b110010;
			4'b0100: back_color6 <= 6'b000100;
			4'b0101: back_color6 <= 6'b010101;
			4'b0110: back_color6 <= 6'b000011;
			4'b0111: back_color6 <= 6'b011011;
			4'b1000: back_color6 <= 6'b100100;
			4'b1001: back_color6 <= 6'b110100;
			4'b1010: back_color6 <= 6'b101010;
			4'b1011: back_color6 <= 6'b111010;
			4'b1100: back_color6 <= 6'b001000;
			4'b1101: back_color6 <= 6'b111100;
			4'b1110: back_color6 <= 6'b001110;
			4'b1111: back_color6 <= 6'b111111;			
		endcase
	end	
// dhr is using different table order
	always @* begin
		case (dhrcolor_number)
			4'b0000: dhr_color6 <= 6'h0;			// black
			4'b0001: dhr_color6 <= 6'b110000;	// deep red			
			4'b0010: dhr_color6 <= 6'b100100;	// brown *			
			4'b0011: dhr_color6 <= 6'b110100;	// orange *
			4'b0100: dhr_color6 <= 6'b000100;	// dark green
			4'b0101: dhr_color6 <= 6'b010101;	// dark gray		
			4'b0110: dhr_color6 <= 6'b001000;	// light green *			
			4'b0111: dhr_color6 <= 6'b111100;	// yellow *
			4'b1000: dhr_color6 <= 6'b000010;	// dark blue * 
			4'b1001: dhr_color6 <= 6'b110010;	// purple *
			4'b1010: dhr_color6 <= 6'b101010;	// light gray
			4'b1011: dhr_color6 <= 6'b111010;	// pink
			4'b1100: dhr_color6 <= 6'b000011;	// medium blue *
			4'b1101: dhr_color6 <= 6'b011011;	// light blue *
			4'b1110: dhr_color6 <= 6'b001110;	// aquamarine
			4'b1111: dhr_color6 <= 6'b111111;	// white	
		endcase
	end				
/* lores colors			
			4'b0000: dhr_color6 <= 6'h0;			// black
			4'b0001: dhr_color6 <= 6'b110000;	// deep red
			4'b0010: dhr_color6 <= 6'b000010;	// dark blue
			4'b0011: dhr_color6 <= 6'b110010;	// purple
			4'b0100: dhr_color6 <= 6'b000100;	// dark green
			4'b0101: dhr_color6 <= 6'b010101;	// dark gray
			4'b0110: dhr_color6 <= 6'b000011;	// medium blue
			4'b0111: dhr_color6 <= 6'b011011;	// light blue
			4'b1000: dhr_color6 <= 6'b100100;	// brown
			4'b1001: dhr_color6 <= 6'b110100;	// orange
			4'b1010: dhr_color6 <= 6'b101010;	// light gray
			4'b1011: dhr_color6 <= 6'b111010;	// pink
			4'b1100: dhr_color6 <= 6'b001000;	// light green
			4'b1101: dhr_color6 <= 6'b111100;	// yellow
			4'b1110: dhr_color6 <= 6'b001110;	// aquamarine
			4'b1111: dhr_color6 <= 6'b111111;	// white			

*/
	always @* begin
		case (nibble)
			4'b0000: RGB_val <= 6'h0;
			4'b0001: RGB_val <= 6'b110000;
			4'b0010: RGB_val <= 6'b000010;
			4'b0011: RGB_val <= 6'b110010;
			4'b0100: RGB_val <= 6'b000100;
			4'b0101: RGB_val <= 6'b010101;
			4'b0110: RGB_val <= 6'b000011;
			4'b0111: RGB_val <= 6'b011011;
			4'b1000: RGB_val <= 6'b100100;
			4'b1001: RGB_val <= 6'b110100;
			4'b1010: RGB_val <= 6'b101010;
			4'b1011: RGB_val <= 6'b111010;
			4'b1100: RGB_val <= 6'b001000;
			4'b1101: RGB_val <= 6'b111100;
			4'b1110: RGB_val <= 6'b001110;
			4'b1111: RGB_val <= 6'b111111;			
		endcase
	end	

endmodule
